#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

using namespace std;

int main() {
  int N, x, y;
  cin >> N;

  vector<pair<int,int>> hollows(4*N);
  for(int i = 0; i < 4*N; i++){
    cin >> x >> y;
    hollows[i] = make_pair(x,y);
  }

  sort(hollows.begin(), hollows.end());
  double area = 0;
  vector<pair<int,int>> open;
  int i = 0;
  start:
  while(i < hollows.size()){
    auto curr = hollows[i];
    printf("%d:%d\n", curr.first, curr.second);
    if(curr.first == -1000000001) {
      i++;
      continue;
    }
    if(!open.empty())  {
      // check para
      int edgeSize = 0;
      for(int j = 0; j < open.size(); j++){
        auto o = open[j];
        if(o.second == curr.second){
          printf("sq candidate 1: %d:%d\n", o.first, o.second);
          edgeSize = curr.first - o.first;
          for(int u = j+1; u < open.size(); u++){
            auto o2 = open[u];
            printf("sq candidate 2: %d:%d\n", o2.first, o2.second);
            if(o2.second - o.second == edgeSize){
              for(int l = i+1; l < hollows.size() && hollows[l].first == curr.first; l++){
                printf("sq candidate 3: %d:%d\n", hollows[l].first, hollows[l].second);
                if(hollows[l].second - curr.second == edgeSize){
                  // found square
                  printf("found square %d:%d %d:%d %d:%d %d:%d\n", curr.first, curr.second, o.first, o.second, o2.first, o2.second, hollows[l].first, hollows[l].second);
                  open.erase(open.begin() + j);
                  open.erase(open.begin() + u - 1);
                  hollows[l].first = -1000000001;
                  area += double(edgeSize * edgeSize);
                  i++;
                  goto start;
                }
              }
            }
          }
        }
      }
      for(int j = open.size()-1; j >= 0; j--){
          auto o1 = open[j];
          printf("chec angled sq from %d %d\n", o1.first, o1.second);
          auto xDist = (curr.first - o1.first);
          auto yDist = (curr.second - o1.second);
          if(xDist < 0 || yDist < 0) continue;
          printf("xdist %d ydist %d\n", xDist, yDist);
          for(int k = 0; k < open.size(); k++){
            auto o = open[k];
            printf("cand: %d %d\n", o.first, o.second);
            if(curr.first - o.first == yDist && o.second - curr.second == xDist) {
              // found left
              for(int l = 0; l < k; l++){
                // find top mid
                o = open[l];
                if(o.first + xDist + yDist == curr.first){
                  printf("found angled square %d:%d %d:%d %d:%d %d:%d\n", curr.first, curr.second, o1.first, o1.second, open[k].first, open[k].second, o.first, o.second);
                  // found angled
                  open.erase(open.begin() + k);
                  open.erase(open.begin() + j - 1);
                  open.erase(open.begin() + l - 2);
                  double X = sqrt(yDist * yDist + xDist * xDist);
                  area += X*X;
                  i++;
                  goto start;
                }
            }
          }
        }
      }
    }
    open.push_back(curr);
    i++;
  }
  cout << area << endl;
  return 0;
}
